
$(document).ready(function(){
	var ws = null;
	
	/**
		Es una buena practica definir los elementos del DOM y no llamarlos
		cada vez que se utilizan para evitar sobrecarga en el navegador.
	**/
	var anterior = "vacio";
	var usuariosConectados = $("#usuarios-conectados");
	var nombre = $("#nombre");
	var usando = $("#usando");	
	var color = "red";
	usando.css("color",color);
	hacerTabla();

	var rojo = $("#rojo");
	var verde = $("#verde");
	var amarillo = $("#amarillo");
	var azul = $("#azul");

	rojo.click(function(){
		color = "red";
		usando.css("color",color);
	});
	
	verde.click(function(){
		color = "green";
		usando.css("color",color);
	});
	
	amarillo.click(function(){
		color = "yellow";
		usando.css("color",color);
		
	});
	
	azul.click(function(){
		color = "blue";
		usando.css("color",color);
	});

	
	var host = "ws://" + window.location.hostname + ":9876/stuff";
	ws = new WebSocket(host);	
	
	//defino las funciones que manejan los eventos de los websockets				
	ws.onopen = function(val){
		usuariosConectados.text("Conectado");
	}
					
	ws.onclose = function(val){
			usuariosConectados.text("Desconectado");
	}
					
	ws.onmessage = function(val){
		// recibo un json con el mensaje y la cantidad de usuarios conectados. Evaluo el json para que lo levante JS
		var datosRecibidos = eval('(' + val.data + ')');
                if(datosRecibidos.tipo=="control-inicio"){
			usuariosConectados.text(datosRecibidos.usuarios);
		}else{
			console.log(datosRecibidos.mensaje.color);
			usuariosConectados.text(datosRecibidos.usuarios);
			$("#" + datosRecibidos.mensaje.idCelda).css("background-color",datosRecibidos.mensaje.color).css("color",datosRecibidos.mensaje.color);
		}

	}																		
																
	
	
	var flagHabilitarDibujo = 0;

	function desHabilitarDibujo(evt){
		flagHabilitarDibujo = 0;
	}
	
	function habilitarDibujo(evt){
		flagHabilitarDibujo = 1;
	}
		
	function dibujar(evt,elemento){
		if(flagHabilitarDibujo==1 && evt.target.id != anterior){
			//console.log(evt.target.id);
			$(elemento).css("background-color",color).css("color",color);
			var mensajeJson = { 'idCelda' : evt.target.id,
                    			'color': color};

			ws.send(JSON.stringify(mensajeJson));
			anterior = evt.target.id;
		}
	}
	
	
	function hacerTabla() {
			columnas = 80;
			filas = 25; 
			
			var diferenciador = 0;
			
			var tabla = $("#tabla");
			
			tabla.mousedown(function(evt){habilitarDibujo(evt)})
				.mouseup(function(evt){desHabilitarDibujo(evt)});
			 
			var id;
			for(var fila = 0; fila < filas ; fila++){
				var trParaFila = $("<tr>");
				for(var columna = 0; columna < columnas ; columna++ ){
					id = "c" + String(fila)+String(columna)+ String(diferenciador);
					$("<td>").addClass("celda").text("0").attr("id",id).appendTo(trParaFila)
					.mousemove(function(evt){dibujar(evt,this)});
					diferenciador++;
				}
				trParaFila.appendTo(tabla);
			}		
	}		

	
		
})