$(document).ready(function(){	

	
	var estado = $("#estado");
	var nombre = $("#nombre");
	var apellido = $("#apellido");
	var edad = $("#edad");
	
	nombre.removeAttr("disabled");
	apellido.removeAttr("disabled");
	edad.removeAttr("disabled");
	
	var usuariosConectados = $("#usuarios-conectados");
	
	var host = "ws://" + window.location.hostname + ":9876/stuff";
	
	ws = new WebSocket(host);	
										
	//defino las funciones que manejan los eventos de los websockets				
	ws.onopen = function(val){
			nombre.removeAttr("disabled");
			apellido.removeAttr("disabled");
			edad.removeAttr("disabled");	
			estado.text("Conectado");
	}
	
	
	ws.onclose = function(val){
			estado.text("Desconectado");
			usuariosConectados.text("Desconectado");
			nombre.attr("disabled","disabled");
			apellido.attr("disabled","disabled");
			edad.attr("disabled","disabled");
	}
	
	ws.onmessage = function(val){
		// recibo un json con el mensaje y la cantidad de usuarios conectados. Evaluo el json para que lo levante JS
		var datosRecibidos = eval('(' + val.data + ')');
			if(datosRecibidos.tipo == "dato"){
					$("#tabla").append("<tr><td>"+ datosRecibidos.nombre + "</td><td>"+ datosRecibidos.apellido + "</td><td>"+datosRecibidos.edad+"</td></tr>");
			}else if(datosRecibidos.tipo == "update"){
					usuariosConectados.text(datosRecibidos.usuarios);		
			}	
		}
		
	edad.keypress(function(tecla){
      	if(tecla.which == 13){
      		tecla.preventDefault();
      		var mensajeJson = { 'nombre' : nombre.val(),
                 				'apellido': apellido.val(),
                 				'edad': edad.val()
             				};
         	ws.send(JSON.stringify(mensajeJson));
         	nombre.val("");
         	apellido.val("");
         	edad.val("");
         	nombre.focus();
       	}
	});

});