/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package websocketserver;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.HashSet;
import java.util.logging.Level;
import java.util.logging.Logger;


public class Chat extends ThreadServerCliente{
    public Chat(Socket clientSocket, HashSet<Socket> clientes) {
        super(clientSocket,clientes);
    }

    @Override
    public void run(){
        boolean finish = false;
        InputStream in = null;
        OutputStream out = null;
        WebSockMgmt req = new WebSockMgmt();
        String mensaje;
        byte[] bytesMensaje;

        /*
         * Hago la conexión con el navegador web
         */

        try {
            in = clientSocket.getInputStream();
            out = clientSocket.getOutputStream();

            req.analizarRequest(in);
            out.write(req.handShakeResponse().getBytes());
            out.flush();
        } catch (IOException ex) {
        }

        String data = "{\"tipo\": \"control-inicio\",\"mensaje\":\"null\",\"usuarios\":\"" + clientes.size() + "\"}";
        enviarATodos(data);

        while (!finish) {
            try {
                bytesMensaje = leerUnidad(in);
                if(isCerrado(bytesMensaje)){
                    finish = true;
                    clientes.remove(clientSocket);
                    System.out.println("Conexion cerrada con: " + clientSocket.getInetAddress() + " " + clientSocket.getPort());
                    System.out.println("Usuarios Conectados: " + clientes.size());
                    data = "{\"tipo\": \"control-inicio\",\"mensaje\":\"null\",\"usuarios\":\"" + clientes.size() + "\"}";
                    enviarATodos(data);
                }else{
                    mensaje = sacarDatos(bytesMensaje);
                    data = "{\"tipo\":\"mensaje\",\"mensaje\": \"" + mensaje + " \",\"usuarios\": \"" + clientes.size() + "\"}";
                    enviarATodos(data);
                }
            } catch (IOException ex) {
                Logger.getLogger(ThreadServerCliente.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}
