package websocketserver;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.HashSet;

public class WebSocketServer {
    int puerto;

    public WebSocketServer(int puerto) {
        this.puerto = puerto;
    }

    public void iniciarServidor() throws IOException, InterruptedException {
        ServerSocket serverSocket = new ServerSocket(puerto);
        HashSet<Socket> set = new HashSet<Socket>();

        while (true) {
            Socket clientSocket = serverSocket.accept();
            System.out.println("Conexion realizada con: " + clientSocket.getInetAddress() + " " + clientSocket.getPort());

            set.add(clientSocket);

            //ThreadServerCliente serverConCliente = new ThreadServerCliente(clientSocket,set);
            //Chat serverConCliente = new Chat(clientSocket,set);
            MoverCuadrados serverConCliente = new MoverCuadrados(clientSocket,set);
            //PizarraRustica serverConCliente = new PizarraRustica(clientSocket,set);
            //BaseDeDatos serverConCliente = new BaseDeDatos(clientSocket,set);
            serverConCliente.start();
        }
    }
}
