
$(document).ready(function(){	
	var ws = null;
	
	/**
		Es una buena practica definir los elementos del DOM y no llamarlos
		cada vez que se utilizan para evitar sobrecarga en el navegador.
	**/
	
	var botonConectar = $("#boton-conectar"); 
	var estado = $("#estado");
	var mensaje = $("#mensaje");
	var usuariosConectados = $("#usuarios-conectados");
	var nombre = $("#nombre");
	var ventanaChat = $("#ventana-chat");


	
	botonConectar.click(function(){
				
				
				if($("#nombre").val()==""){
					alert("Definir nombre antes de conectar");
					
				}else{
					
					var host = "ws://" + window.location.hostname + ":9876";
					ws = new WebSocket(host);	
										
					//defino las funciones que manejan los eventos de los websockets				
					ws.onopen = function(val){
					if($("#estado").text()=="Desconectado"){
								botonConectar.attr("disabled","disabled");
								botonConectar.css("color","#2D2D2D");
								estado.text("Conectado");
								mensaje.removeAttr("disabled");
								mensaje.val("");
								mensaje.focus();
								nombre.attr("disabled","disabled");
						}
					}
					
					ws.onclose = function(val){
							estado.text("Desconectado");
							botonConectar.css("color","#FFCC55");
							botonConectar.removeAttr("disabled");
							mensaje.attr("disabled","disabled");
							mensaje.val("Conectar con el servidor...");
							usuariosConectados.text("Desconectado");
					}
					
					ws.onmessage = function(val){
						// recibo un json con el mensaje y la cantidad de usuarios conectados. Evaluo el json para que lo levante JS
							var datosRecibidos = eval('(' + val.data + ')');
							
							if(datosRecibidos.tipo=="mensaje"){
								ventanaChat.append(datosRecibidos.mensaje + "<br/>");	
								usuariosConectados.text(datosRecibidos.usuarios);	
								ventanaChat.animate({scrollTop: ventanaChat.prop("scrollHeight") - ventanaChat.height()}, 'slow');		
							}else if(datosRecibidos.tipo=="control-inicio"){
								usuariosConectados.text(datosRecibidos.usuarios);
							}							
						}																		
				}															
	})
	
	nombre.keypress(function(tecla){
      	if(tecla.which == 13){
      		tecla.preventDefault();
			botonConectar.trigger('click');
       	}
	});
	
	mensaje.keypress(function(tecla){
      	if(tecla.which == 13){
      		tecla.preventDefault();
			ws.send(nombre.val() + ": " + mensaje.val());
       		mensaje.val("");
       	}
	});	
})