
$(document).ready(function(){
	var host = "ws://" + window.location.hostname + ":9876/stuff";
	ws = new WebSocket(host);	

	var moviendoYO = false;
	var cuadrado = $("#cuadrado");
	var estado = $("#estado");
	var posx = $("#x");
	var posy = $("#y");
	
	cuadrado.draggable({ containment: 'parent' }); //esto define que el cuadrado se pueda arrastrar jQueryUI
	
	
	ws.onopen = function(val){
		estado.text("Conectado");
	}
	
	ws.onclose = function(val){
		estado.text("Desconectado");
		
	}
	
	ws.onmessage = function(val){
		
		if(moviendoYO == false){
			var datosRecibidos = eval('(' + val.data + ')');
			cuadrado.css({'top': datosRecibidos.top -114 , 'left' : datosRecibidos.left -59 })

			posx.text(datosRecibidos.left);
			posy.text(datosRecibidos.top);
			
		}	
	}
					
	// con este evento mando las posiciones a medida que se mueve.
	
	cuadrado.bind( "drag", function(event, ui) {
  		//position es un metodo definido por jQuery UI que da la posicion de la izquierda y del techo.
		var posicion = $(this).position();
		moviendoYO = true;
		var mensajeJson = { 'top' : posicion.top,
                 			'left': posicion.left};
                 			
		ws.send(JSON.stringify(mensajeJson));
		posx.text(mensajeJson.left);
		posy.text(mensajeJson.top);
	});			
	
	// con esto indico que dejé de moverlo
	
	cuadrado.bind( "dragstop", function(event, ui) {
		moviendoYO=false;
	});
	
})