/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package websocketserver;

import argo.jdom.JdomParser;
import argo.saj.InvalidSyntaxException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.HashSet;
import java.util.logging.Level;
import java.util.logging.Logger;

public class BaseDeDatos extends ThreadServerCliente {

    public BaseDeDatos(Socket clientSocket, HashSet<Socket> clientes) {
        super(clientSocket, clientes);
    }

    @Override
    public void run() {
        boolean finish = false;
        InputStream in = null;
        OutputStream out = null;
        WebSockMgmt req = new WebSockMgmt();
        String mensaje;
        byte[] bytesMensaje;

        /*
         * Hago la conexión con el navegador web
         */

        try {
            in = clientSocket.getInputStream();
            out = clientSocket.getOutputStream();

            req.analizarRequest(in);
            out.write(req.handShakeResponse().getBytes());
            out.flush();
        } catch (IOException ex) {
        }

        String data = "{\"tipo\": \"update\",\"usuarios\":\"" + clientes.size() + "\"}";
        enviarATodos(data);
        JdomParser parserJson = new JdomParser();
        String nombre = null, apellido = null, edad = null;
        while (!finish) {
            try {
                bytesMensaje = leerUnidad(in);
                if (isCerrado(bytesMensaje)) {
                    finish = true;
                    clientes.remove(clientSocket);
                    System.out.println("Conexion cerrada con: " + clientSocket.getInetAddress() + " " + clientSocket.getPort());
                    System.out.println("Usuarios Conectados: " + clientes.size());
                    data = "{\"tipo\": \"update\",\"usuarios\":\"" + clientes.size() + "\"}";
                    enviarATodos(data);
                } else {
                    mensaje = sacarDatos(bytesMensaje);
                    try {
                        nombre = parserJson.parse(mensaje).getStringValue("nombre");
                        apellido = parserJson.parse(mensaje).getStringValue("apellido");
                        edad = parserJson.parse(mensaje).getStringValue("edad");
                    } catch (InvalidSyntaxException ex) {
                    }

                    data = "{\"tipo\":\"dato\",\"nombre\":\"" + nombre + "\",\"apellido\":\"" + apellido + "\",\"edad\":\"" + edad + "\"}";
                    new Thread(){
                        private String nombre,apellido, edad;
                        Thread initialize(String nombre, String apellido, String edad){
                            this.nombre = nombre;
                            this.apellido = apellido;
                            this.edad = edad;
                            return this;
                        }
                        @Override
                        public void run() {
                            Runtime run = Runtime.getRuntime();
                            try {
                                run.exec("php.exe -f persistir.php " + this.nombre + " " + this.apellido + " " + this.edad);
                            } catch (IOException ex) {
                                Logger.getLogger(BaseDeDatos.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                    }.initialize(nombre,apellido,edad).start();
                    enviarATodos(data);
                }
            } catch (IOException ex) {
                Logger.getLogger(ThreadServerCliente.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}
